public class Search {

   static int linearSearch(int[] arr, int x) {
      int n = arr.length;
      for (int i=0; i < n; i++) {
         if (arr[i] == x) {
            return i;
         }
      }
      return -1;
   }

   static int improvedLinearSearch(int[] arr, int x) {
      int n = arr.length;
      int last = arr[n-1];
      arr[n-1] = x;
      int i = 0;
      while (true) {
         if (arr[i] == x) {
            break;
         }
         i++;
      }      
      arr[n-1] = last;
      return (i < n-1 ? i : (x == last ? n - 1 : -1));       
   }
   
   static int binarySearch(int[] a, int x) {
      int left = 0;
      int right = a.length - 1;
      while (left <= right) {
         int middle = (left + 1) / 2 + right/2;
         if (x < a[middle]) {
            right = middle - 1;
         } else if (x == a[middle]) {
            return middle;
         } else {
            left = middle + 1;
         }
      }
      return -1;
   }
   
   static int interpolationSearch(int[] a, int x) {
      throw new RuntimeException("this method was removed");
   }   
}
